<template>
  <a-spin :spinning="confirmLoading">
    <JFormContainer :disabled="disabled">
      <template #detail>
        <a-form ref="formRef" class="antd-modal-form" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-row>
            <a-col :span="24">
              <a-form-item label="套餐类型" v-bind="validateInfos.marketType">
                <j-dict-select-tag v-model:value="formData.marketType" dictCode="dict_market_type" placeholder="请选择套餐类型" allow-clear />
              </a-form-item>
            </a-col>
            <a-col :span="24">
              <a-form-item label="套餐名称" v-bind="validateInfos.planName">
                <a-input v-model:value="formData.planName" placeholder="请输入套餐名称" allow-clear />
              </a-form-item>
            </a-col>
            <a-col :span="24">
              <a-form-item label="关键词数量" v-bind="validateInfos.keywordCount">
                <a-input-number v-model:value="formData.keywordCount" placeholder="请输入关键词数量" style="width: 100%" />
              </a-form-item>
            </a-col>
            <a-col :span="24">
              <a-form-item label="关键词达标目标" v-bind="validateInfos.target">
                <a-input-number v-model:value="formData.target" placeholder="请输入关键词达标目标" style="width: 100%" />
              </a-form-item>
            </a-col>
            <a-col :span="24">
              <a-form-item label="服务时间" v-bind="validateInfos.serviceTime">
                <a-input-number v-model:value="formData.serviceTime" placeholder="请输入服务时间" style="width: 100%" />
              </a-form-item>
            </a-col>
            <a-col :span="24">
              <a-form-item label="价格" v-bind="validateInfos.price">
                <a-input-number v-model:value="formData.price" placeholder="请输入价格" style="width: 100%" />
              </a-form-item>
            </a-col>

            <div class="ant-modal-title" id="vcDialogTitle0" style="margin-bottom: 15px;">SEO指标</div>

            <a-col :span="24">
              <a-form-item label="文章" v-bind="validateInfos.article">
                <a-input-number v-model:value="formData.article" placeholder="文章数量" style="width: 100%" />
              </a-form-item>
            </a-col>

            <a-col :span="24">
              <a-form-item label="客座博客" v-bind="validateInfos.blog">
                <a-input-number v-model:value="formData.blog" placeholder="博客数量" style="width: 100%" />
              </a-form-item>
            </a-col>

            <a-col :span="24">
              <a-form-item label="指定词" v-bind="validateInfos.specifyKeyword">
                <a-input-number v-model:value="formData.specifyKeyword" placeholder="指定词数量" style="width: 100%" />
              </a-form-item>
            </a-col>

            <a-col :span="24">
              <a-form-item label="长尾词" v-bind="validateInfos.longTailKeyword">
                <a-input-number v-model:value="formData.longTailKeyword" placeholder="长尾词数量" style="width: 100%" />
              </a-form-item>
            </a-col>

            <a-col :span="24">
              <a-form-item label="外链" v-bind="validateInfos.externalLinks">
                <a-input-number v-model:value="formData.externalLinks" placeholder="外链数量" style="width: 100%" />
              </a-form-item>
            </a-col>

            <a-col :span="24">
              <a-form-item label="访问量" v-bind="validateInfos.pageView">
                <a-input-number v-model:value="formData.pageView" placeholder="访问数量" style="width: 100%" />
              </a-form-item>
            </a-col>

          </a-row>
        </a-form>
      </template>
    </JFormContainer>
  </a-spin>
</template>

<script lang="ts" setup>
  import { ref, reactive, defineExpose, nextTick, defineProps, computed, onMounted } from 'vue';
  import { defHttp } from '/src/utils/http/axios';
  import { useMessage } from '/src/hooks/web/useMessage';
  import JDictSelectTag from '/src/components/Form/src/jeecg/components/JDictSelectTag.vue';
  import { getValueType } from '/src/utils';
  import { saveOrUpdate } from '../SubscribePlan.api';
  import { Form } from 'ant-design-vue';
  import JFormContainer from '/src/components/Form/src/container/JFormContainer.vue';

  const props = defineProps({
    formDisabled: { type: Boolean, default: false },
    formData: { type: Object, default: () => ({}) },
    formBpm: { type: Boolean, default: true },
  });
  const formRef = ref();
  const useForm = Form.useForm;
  const emit = defineEmits(['register', 'ok']);
  const formData = reactive<Record<string, any>>({
    id: '',
    marketType: '',
    planName: '',
    keywordCount: undefined,
    target: undefined,
    serviceTime: undefined,
    price: undefined,
    article: undefined,
    blog: undefined,
    specifyKeyword: undefined,
    longTailKeyword: undefined,
    externalLinks: undefined,
    pageView: undefined,
  });
  const { createMessage } = useMessage();
  const labelCol = ref<any>({ xs: { span: 24 }, sm: { span: 5 } });
  const wrapperCol = ref<any>({ xs: { span: 24 }, sm: { span: 16 } });
  const confirmLoading = ref<boolean>(false);
  //表单验证
  const validatorRules = reactive({
    marketType: [{ required: true, message: '请输入套餐类型!' }],
    planName: [{ required: true, message: '请输入套餐名称!' }],
    keywordCount: [{ required: true, message: '请输入关键词数量!' }],
    target: [{ required: true, message: '请输入关键词达标目标!' }],
    serviceTime: [{ required: true, message: '请输入服务时间!' }],
    price: [{ required: true, message: '请输入价格!' }],
    article: [{ required: true, message: '请输入文章数量!' }],
    blog: [{ required: true, message: '请输入客座博客数量!' }],
    specifyKeyword: [{ required: true, message: '请输入指定关键词数量!' }],
    longTailKeyword: [{ required: true, message: '请输入长尾词数量!' }],
    externalLinks: [{ required: true, message: '请输入外链数量!' }],
    pageView: [{ required: true, message: '请输入访问数量!' }],
  });
  const { resetFields, validate, validateInfos } = useForm(formData, validatorRules, { immediate: false });

  // 表单禁用
  const disabled = computed(() => {
    if (props.formBpm === true) {
      if (props.formData.disabled === false) {
        return false;
      } else {
        return true;
      }
    }
    return props.formDisabled;
  });

  /**
   * 新增
   */
  function add() {
    edit({});
  }

  /**
   * 编辑
   */
  function edit(record) {
    nextTick(() => {
      resetFields();
      const tmpData = {};
      Object.keys(formData).forEach((key) => {
        if (record.hasOwnProperty(key)) {
          tmpData[key] = record[key];
        }
      });
      //赋值
      Object.assign(formData, tmpData);
    });
  }

  /**
   * 提交数据
   */
  async function submitForm() {
    // 触发表单验证
    await validate();
    confirmLoading.value = true;
    const isUpdate = ref<boolean>(false);
    //时间格式化
    let model = formData;
    if (model.id) {
      isUpdate.value = true;
    }
    //循环数据
    for (let data in model) {
      //如果该数据是数组并且是字符串类型
      if (model[data] instanceof Array) {
        let valueType = getValueType(formRef.value.getProps, data);
        //如果是字符串类型的需要变成以逗号分割的字符串
        if (valueType === 'string') {
          model[data] = model[data].join(',');
        }
      }
    }
    await saveOrUpdate(model, isUpdate.value)
      .then((res) => {
        if (res.success) {
          createMessage.success(res.message);
          emit('ok');
        } else {
          createMessage.warning(res.message);
        }
      })
      .finally(() => {
        confirmLoading.value = false;
      });
  }

  defineExpose({
    add,
    edit,
    submitForm,
  });
</script>

<style lang="less" scoped>
  .antd-modal-form {
    padding: 14px;
  }
</style>
